Subject: bug#12095: Protecting pointer on bytevector with guardian does not protect memory

From: [email-masked] (Ludovic Courtès)
Date: Mon, 08 Oct 2012 15:44:49 +0200

Hi,

Daniel Hartwig <[email-masked]> skribis:

> On 8 October 2012 04:38, Ludovic Courtès <[email-masked]> wrote:
>>>> This is expected to fail: ‘bytevector->pointer’ creates a weak reference
>>>> from the returned pointer object to the given bytevector.  So when the
>>>> pointer object is reclaimed, the bytevector can be reclaimed too, hence
>>>> the problem you’re observing.  (And no, guardians don’t protect objects
>>>> from garbage collection.)
>>>
>>> If I understand correctly, there is never any non-weak reference to
>>> the bv above and so it can be collected at any time.
>>
>> There’s a weak reference from the pointer object to the bytevector.
>>
>> Once that pointer object has been collected (as in the example above),
>> the bytevector can be collected anytime.
>
> Right.  But then the pointer is being collected even though it remains
> inside the guardian, in the example it is never extracted from there.

Well, when the object reaches the guardian’s zombie list, that’s because
it’s been finalized, so any weak references from that object can also be
nullified.

Anyway, guardians are not a mechanism to protect objects from being
GC’d.  To prevent the bytevector from being GC’d, you should either keep
the pointer object or the bytevector itself in non-GC’d memory, such as
a global variable or hash table.

How does it help?  Should we close the bug?  :-)

Thanks,
Ludo’.